Magellan Linux

Diff of /trunk/mage/usr/lib/mage/smage2.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 199 by niro, Sun Aug 21 21:23:48 2005 UTC revision 2589 by niro, Fri Feb 14 09:00:35 2014 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2    # $Id$
3    
4  # compiles/installs .smage2 source install scripts  # compiles/installs .smage2 source install scripts
5  # needs pkgbuild_dir (mage)  # needs pkgbuild_dir (mage)
6    
7  # SMAGE2  # TODO: record dynlib, gz | xz database
 # $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.30 2005-08-21 21:23:48 niro Exp $  
8    
 #01.10.2004  
 # added ccache support  
 # added distcc support  
9    
10  ## setup ##  # set default user mage.rc
11  PKGSUFFIX="mpk"  : ${MAGERC="/etc/mage.rc"}
 SMAGENAME="$1"  
 SMAGESUFFIX="smage2"  
 #SOURCEDIR="/bootstrap/sources"  
 #SMAGESCRIPTSDIR="/bootstrap/smage2-install-scripts"  
 #SMAGE2RSYNC="rsync://192.168.0.2/smage2-scripts"  
 MLIBDIR=/usr/lib/mage  
 SMAGEVERSION="$( < ${MLIBDIR}/version)"  
12    
13  # export default C locale  # export default C locale
14  export LC_ALL=C  export LC_ALL=C
15    
16  source /etc/mage.rc  source /etc/mage.rc.global
17    source ${MAGERC}
18  showversion() {  source ${MLIBDIR}/mage4.functions.sh
19   echo -en "Magellan Source Install v${SMAGEVERSION} "  source ${MLIBDIR}/smage2.functions.sh
  echo -e  "-- Niels Rogalla (niro@magellan-linux.de)"  
 }  
   
 die() {  
  xtitleclean  
  echo "SMAGE failed: $@"  
  exit 1  
 }  
   
 xtitle() {  
  if [ ${TERM} == "xterm" ]  
  then  
  echo -ne "\033]0;[sMage: $@]\007"  
  fi  
  return 0  
 }  
   
 xtitleclean() {  
  if [ ${TERM} == "xterm" ]  
  then  
  echo -ne "\033]0;\007"  
  fi  
  return 0  
 }  
   
 syncsmage2() {  
  xtitle "Updating smage2-script tree ..."  
  local i  
  for i in ${SMAGE2RSYNC}  
  do  
  rsync \  
  --recursive \  
  --links \  
  --perms \  
  --times \  
  --devices \  
  --timeout=600 \  
  --verbose \  
  --compress \  
  --progress \  
  --stats \  
  --delete \  
  --delete-after \  
  ${i} ${SMAGESCRIPTSDIR}  
   
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
   
  done  
   
  #clean up backup files (foo~)  
  find ${SMAGESCRIPTSDIR} -name *~ -exec rm '{}' ';'  
   
  xtitleclean  
 }  
   
 # $1 filename  
 get_db_md5_sum() {  
  local DB_FILE  
  local MD5_FILE  
  local i  
   
  DB_ENTRY="$(basename $1)"  
  MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} ${SMAGESUFFIX})"  
   
  i="$(cat ${MD5_FILE}| grep ${DB_ENTRY} | cut -d' ' -f1)"  
   
  echo "${i}"  
 }  
   
 download_sources() {  
   
  [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0  
   
  local EOA=${#SRC_URI[*]}  
  local my_SRC_URI  
  local my_SRC_URI_DEST  
  local my_SRC_URI_MIRROR  
  local my_SOURCEDIR  
  local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"  
  local FETCHING  
  local i mirror  
   
   
  #install SRCDIR/PNAME if not exist  
  [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}  
   
  # check if FETCHING is needed  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} &> /dev/null )  
  if [[ $? == 0 ]]  
  then  
  # md5's ok, not fetching needed  
  FETCHING=false  
  else  
  FETCHING=true  
  fi  
   
  for ((i=0; i < EOA; i++))  
  do  
  # url to file  
  my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"  
   
  # subdir in sources dir; the my_SRCI_URI file goes to there  
  my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"  
   
  # if my_src_uri_dest is not equal my_src_uri; than an other dir is used  
  if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]  
  then  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}/${my_SRC_URI_DEST}"  
  else  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}"  
  fi  
   
  # if an mirrored file than replace first the mirror uri  
  if [ -n "$(echo ${my_SRC_URI} | grep 'mirror://')" ]  
  then  
  for mirror in ${MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|mirror:/|${mirror}/sources|g")"  
   
  #echo "DEBUG: ${MY_SRC_URI}"  
  if [[ ${FETCHING} == true ]]  
  then  
  echo "==> fetching ${my_SRC_URI_MIRROR}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  else  
  #echo "DEBUG: ${SRC_URI[${i}]}"  
  if [[ ${FETCHING} == true ]]  
  then  
  echo "==> fetching ${my_SRC_URI}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI}"  
 # only needed to run through a list of mirrors  
 # if [ "$?" == "0" ]  
 # then  
 # break  
 # else  
 # continue  
 # fi  
  fi  
  fi  
   
  # unset them to be shure  
  unset my_SRC_URI  
  unset my_SRC_URI_DEST  
  unset my_SRC_URI_MIRROR  
  unset my_SOURCEDIR  
  done  
   
  # recheck md5 sums  
  echo  
  echo ">== Checking MD5 sums:"  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} ) || die "md5 failed"  
  echo  
   
  # not needed anymore  
  unset SRC_URI  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_prepare() {  
  echo "no src_prepare defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_compile() {  
  echo "no src_compile defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_install() {  
  echo "no src_install defined"  
  sleep 2  
  return 0  
 }  
   
 mconfigure() {  
  if [ -x ./configure ]  
  then  
  ./configure \  
  --prefix=/usr \  
  --host=${CHOST} \  
  --mandir=/usr/share/man \  
  --infodir=/usr/share/info \  
  --datadir=/usr/share \  
  --sysconfdir=/etc \  
  --localstatedir=/var/lib \  
  "$@" || die "mconfigure failed"  
  else  
  echo "configure is not an executable ..."  
  exit 1  
  fi  
 }  
   
 minstall() {  
  if [ -f ./[mM]akefile -o -f ./GNUmakefile ] ; then  
  make prefix=${BINDIR}/usr \  
  datadir=${BINDIR}/usr/share \  
  infodir=${BINDIR}/usr/share/info \  
  localstatedir=${BINDIR}/var/lib \  
  mandir=${BINDIR}/usr/share/man \  
  sysconfdir=${BINDIR}/etc \  
  "$@" install || die "minstall failed"  
         else  
                 die "no Makefile found"  
         fi  
 }  
   
 mmake() {  
  make ${MAKEOPTS} ${EXTRA_EMAKE} "$@"  
 }  
   
 munpack() {  
  local SRCFILE  
  local IFTAR  
  local DEST  
   
  SRCFILE=$1  
   
  if [ -z "$2" ]  
  then  
  DEST=${BUILDDIR}  
  else  
  DEST=$2  
  fi  
   
  case "${SRCFILE##*.}" in  
  bz2)  
  IFTAR="$(basename $SRCFILE .bz2)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
  then  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  fi  
  ;;  
  gz)  
  IFTAR="$(basename $SRCFILE .gz)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
  then  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  fi  
  ;;  
  tbz2)  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  ;;  
  tgz)  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  ;;  
  *)  
  die "munpack failed"  
  ;;  
  esac  
 }  
   
 mpatch() {  
  local PATCHOPTS  
  local PATCHFILE  
   
  PATCHOPTS=$1  
  PATCHFILE=$2  
   
  patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}  
 }  
   
   
 minstalldocs() {  
  local docfiles  
   
  docfiles="$@"  
   
  if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]  
  then  
  install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."  
  fi  
   
  for i in ${docfiles}  
  do  
  cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."  
  install -m 0644 ${SRCDIR}/${i}.gz \  
  ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."  
  done  
 }  
   
 mstriplibs() {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 mstripbins() {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 sminclude() {  
  local i  
   
  if [[ -n "$@" ]]  
  then  
  for i in $@  
  do  
  echo "--- Including ${SMAGESCRIPTSDIR}/include/${i}.sminc"  
  source ${SMAGESCRIPTSDIR}/include/${i}.sminc  
  done  
  echo  
  fi  
 }  
   
 setup_distcc_environment(){  
  if [ -x /usr/bin/distcc ]  
  then  
  echo "Using DistCC for compilation ..."  
  export PATH=/usr/lib/distcc/bin:${PATH} || die "distcc: could not export new $PATH"  
   
  #export distcc as compiler  
 # export CC="distcc"  
 # export CXX=distcc  
   
  export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"  
   
   
  #ccache + distcc together  
  if [ "${SMAGE_USE_CCACHE}" == "true" ]  
  then  
  if [ -x /usr/bin/ccache ]  
  then  
  echo "Preparing DistCC to work together with CCache ..."  
  #export CCACHE_PREFIX="distcc" || die "distcc: could not set ccach_prefix"  
 # export CC="ccache distcc"  
 # export CXX="ccache distcc"  
  fi  
  fi  
   
  #creating distcc tempdir  
  install -o distcc -g daemon -d ${DISTCC_DIR}  
  chmod 1777 ${DISTCC_DIR}  
  fi  
 }  
20    
21  setup_ccache_environment(){  # export default path
22   if [ -x /usr/bin/ccache ]  export PATH="${PATH}:${MLIBDIR}"
  then  
  echo "Using CCache for compilation ..."  
  export PATH=/usr/lib/ccache/bin:${PATH} || die "ccache: could not export new $PATH"  
  #unset CC CXX  
  fi  
 }  
   
   
 # fixes given dependencies to match a MAGE_TARGET  
 # fix_mage_deps -target s/depend # <-- note -target !  
 fix_mage_deps() {  
  local target="$1"  
  local depend="$2"  
  local NDEPEND  
  local sym dep cat pver pname  
   
  # deps and provides are special  
  # they must be fixed to match the target  
   
  # run this only if target and depend is not empty  
  if [ -n "${target}" ] && [ -n "${depend}" ]  
  then  
  # fix DEPEND  
  while read sym dep  
  do  
  cat="$(dirname ${dep})"  
  # change if not virtual  
  if [[ ${cat} != virtual ]]  
  then  
  # fix pver to target-pver  
  # to get pname-target-pver  
23    
24   # doing it backwards !  ## setup ##
25   pver="${dep##*-}"  SMAGENAME="$1"
26   pname=$(basename ${dep/-${pver}/})  SMAGEVERSION="$(< ${MLIBDIR}/version)"
  fi  
   
  # do not add empty lines  
  if [ -z "${NDEPEND}" ]  
  then  
  NDEPEND="${sym} ${cat}/${pname}${target}-${pver}"  
  else  
  NDEPEND="${NDEPEND}  
  ${sym} ${cat}/${pname}${target}-${pver}"  
  fi  
   
  unset cat pname pver  
  done << EOF  
 ${depend}  
 EOF  
  # set NDEPEND to DEPEND  
  depend="${NDEPEND}"  
  fi  
   
  echo "${depend}"  
 }  
   
 # build_mage_script(): helper functions for regen_mage_tree()  
 # generates an mage file with given information in smage file  
 # needs at least:  
 #   PNAME                 name of pkg  
 #   PVER                  version  
 #   PBUILD                revision  
 #   PCATEGORIE            categorie of the pkg  
 #   STATE                 state of pkg stable|unstable|old  
 #   DESCRIPTION           va short description (opt)  
 #   HOMEPAGE              homepage (opt)  
 #   DEPEND                runtime dependencies (opt)  
 #   SDEPEND               add. needed deps to build the pkg (opt)  
 #   PROVIDE               provides a virtual (opt)  
 #  
 # special tags:  
 #   PKGTYPE               type of pkg  
 #   INHERITS              which functions get included  
 #   SPECIAL_FUNCTIONS     special functions wich should also be added  
 #                         warning: they get killed before the build starts !  
 #  
 #   MAGE_TREE_DEST        target destination of the generated tree  
 #   REGEN_MAGE_TREE       set to 'true' to enable this  
 #  
 # gets called with build_mage_script target  
 build_mage_script()  
 {  
  local magefile  
  local dest  
  local target  
  local sym  
  local depname  
   
  # if MAGE_TREE_DEST not set use BUILDDIR  
  : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}  
   
  # determinate which suffix this mage file should get, if any  
  [ -n "$1" ] && target="-$1"  
   
  # name of magefile  
  magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"  
   
  # destination to magefile  
  dest="${MAGE_TREE_DEST}/${PCATEGORIE}/${PNAME}${target}/${magefile}"  
   
  # show what we are doing  
  echo "Generating Mage file:"  
  echo "  ${dest}"  
   
  install -d "$(dirname ${dest})"  
  # now build the mage file  
  > ${dest}  
   
  # header  
  echo '# $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.30 2005-08-21 21:23:48 niro Exp $' >> ${dest}  
  echo  >> ${dest}  
   
  # pgkname and state  
  echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}-${PBUILD}\"" >> ${dest}  
  echo "STATE=\"${STATE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # description and homepage  
  echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}  
  echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # special tags and vars  
  echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}  
  # add special vars  
  if [ -n "${SPECIAL_VARS}" ]  
  then  
  local i  
  for i in ${SPECIAL_VARS}  
  do  
  # being tricky here :)  
  echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}  
  done  
  echo  >> ${dest}  
  fi  
  # add at least all includes  
  if [ -n "${INHERITS}" ]  
  then  
  echo -n "minclude"  >> ${dest}  
  local i  
  for i in ${INHERITS}  
  do  
  echo -n " ${i}"  >> ${dest}  
  done  
  echo  >> ${dest}  
  fi  
  echo >> ${dest}  
   
  # deps and provides  
  echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}  
  echo >> ${dest}  
  echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}  
  echo >> ${dest}  
  echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # add special functions  
  if [ -n "${SPECIAL_FUNCTIONS}" ]  
  then  
  local i  
  for i in ${SPECIAL_FUNCTIONS}  
  do  
  # add to mage (quotes needed !)  
  typeset -f "${i}" >> ${dest}  
  # unset to be safe (quotes needed !)  
  #unset "${i}" <-- later to get every target built  
  done  
  echo  >> ${dest}  
  fi  
   
  # pre|post-install|removes  
  typeset -f preinstall >> ${dest}  
  echo  >> ${dest}  
  typeset -f postinstall >> ${dest}  
  echo  >> ${dest}  
  typeset -f preremove >> ${dest}  
  echo  >> ${dest}  
  typeset -f postremove >> ${dest}  
  echo  >> ${dest}  
 }  
   
 regen_mage_tree()  
 {  
  local i  
   
  # build them only if requested  
  if [[ ${REGEN_MAGE_TREE} = true ]]  
  then  
  # run it without targets  
  if [ -z "${MAGE_TARGETS}" ]  
  then  
  echo  
  build_mage_script  
  echo  
  else  
   
  # build for each target an mage file  
  # run it with several targets  
  for i in ${MAGE_TARGETS}  
  do  
  echo  
  build_mage_script "${i}"  
  echo  
  done  
  fi  
  fi  
27    
28   # now unset all uneeded vars to be safe  # expand PKGDIR, BUILDDIR and BINDIR with MROOT
29   # unset PKGNAME <-- don't do that; smage needs this var  if [[ -n ${MROOT} ]]
30   # unset to be safe (quotes needed !)  then
31   for i in ${SPECIAL_FUNCTIONS}   export PKGDIR=${MROOT}/${PKGDIR}
32   do   export BUILDDIR=${MROOT}/${BUILDDIR}
33   unset "${i}"   export BINDIR=${MROOT}/${BINDIR}
34   done  fi
  unset SPECIAL_FUNCTIONS  
  for i in ${SPECIAL_VARS}  
  do  
  unset "${i}"  
  done  
  unset SPECIAL_VARS  
  unset STATE  
  unset DESCRIPTION  
  unset HOMEPAGE  
  unset PKGTYPE  
  unset INHERITS  
  unset DEPEND  
  unset SDEPEND  
  unset PROVIDE  
  unset preinstall  
  unset postinstall  
  unset preremove  
  unset postremove  
 }  
35    
36  # print out our version  # print out our version
37  showversion  showversion
38  echo  echo
39    
40  if [ -z "$1" ]  if [[ -z ${SMAGENAME} ]]
41  then  then
42   echo "No .smage2 file given. Exiting."   echo "No .smage2 file given. Exiting."
43   echo   echo
44   exit 1   exit 1
45  fi  fi
46    
47    # load supported mage features
48    load_mage_features
49    
50  # updating smage2-scripts  # updating smage2-scripts
51  if [ "$1" == "update" ]  if [[ $1 = update ]]
52  then  then
53   if [ ! -d ${SOURCEDIR} ]   if [ ! -d ${SOURCEDIR} ]
54   then   then
# Line 657  then Line 59  then
59  fi  fi
60    
61  # creates md5sums for smages to given dir  # creates md5sums for smages to given dir
62  if [ "$1" == "calcmd5" ]  if [[ $1 = calcmd5 ]]
63  then  then
64   if [ $# -ge 3 ]   if [ $# -ge 2 ]
65   then   then
66   SMAGENAME="$2"   SMAGENAME="$2"
67   MD5DIR="$3"   MD5DIR="$3"
68   source ${SMAGENAME} || die "download source failed"   [[ -z ${MD5DIR} ]] && MD5DIR="$(dirname ${SMAGENAME})/md5"
69    
70     smagesource ${SMAGENAME} || die "download source failed"
71    
72   # overridable sourcedir; must be declared after source of the smage2   # overridable sourcedir; must be declared after source of the smage2
73   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"
# Line 709  then Line 113  then
113   unset my_SRC_URI_MIRROR   unset my_SRC_URI_MIRROR
114   unset my_SOURCEDIR   unset my_SOURCEDIR
115   done   done
116    
117   echo   echo
118   echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."   echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."
119   echo   echo
120   else   else
121   echo "Usage: Calculating MD5 Sums:"   echo "Usage: Calculating MD5 Sums:"
122   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME /path/to/MD5DIR"   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME [/path/to/MD5DIR]"
123   echo   echo
124   echo   echo
125   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."
126   echo   echo
127   exit 1   exit 1
128   fi   fi
129    
130   exit 0   exit 0
131  fi  fi
132    
# Line 737  then Line 141  then
141   # get smage   # get smage
142   SMAGENAME="$2"   SMAGENAME="$2"
143   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
144   source ${SMAGENAME} || die "download source failed"   smagesource ${SMAGENAME} || die "download source failed"
145    
146   download_sources   download_sources
147   exit 0   exit 0
148  fi  fi
149    
150  if [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ]  # regen-mage-tree
151    if [ "$1" == "only-regen-tree" -a -n "$2" ]
152  then  then
153   die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."   # set correct SMAGENAME
154  fi   SMAGENAME="$2"
155     MD5DIR="$(dirname ${SMAGENAME})/md5"
156     smagesource ${SMAGENAME} || die "regen: smage2 not found"
157    
158  if [ -z "`basename ${SMAGENAME}|grep .${SMAGESUFFIX}`" ]   regen_mage_tree
 then  
  die "File '`basename ${SMAGENAME}`' is not a sMage v${SMAGEVERSION} file. Aborting."  
 fi  
159    
160  if [ -z "${SOURCEDIR}" ]   # build several subpackages
161  then   if [[ -n ${SPLIT_PACKAGES} ]]
162   die "\$SOURCEDIR not found. Please setup your mage.rc correctly."   then
163  fi   split_save_variables
164     for subpackage in ${SPLIT_PACKAGES}
165     do
166     # get the right variables for the split
167     export PNAME="${subpackage}"
168     split_info_${subpackage}
169     # fix PCATEGORIE -> PCAT
170     if [[ ! -z ${PCATEGORIE} ]]
171     then
172     PCAT="${PCATEGORIE}"
173     unset PCATEGORIE
174     fi
175     # build md5sum for existing packages
176     generate_package_md5sum \
177     --pcat "${PCAT}" \
178     --pname "${PNAME}" \
179     --pver "${PVER}" \
180     --pbuild "${PBUILD}" \
181     --parch "${ARCH}"
182     # restore smage environment
183     split_restore_variables
184     done
185     # unset all saved smage variables
186     split_unset_variables
187    
188  if [ -z "${SMAGESCRIPTSDIR}" ]   else
189  then   # build md5sum for existing packages
190   die "\$SMAGESCRIPTSDIR not found. Please setup your mage.rc correctly."   generate_package_md5sum \
191  fi   --pcat "${PCAT}" \
192     --pname "${PNAME}" \
193     --pver "${PVER}" \
194     --pbuild "${PBUILD}" \
195     --parch "${ARCH}"
196     fi
197    
198  if [ -z "${SMAGE2RSYNC}" ]   exit 0
 then  
  echo "\$SMAGE2RSYNC not found. Please setup your mage.rc correctly."  
  exit 1  
199  fi  fi
200    
201  if [ -z "${BINDIR}" ]  if [ "$1" == "--create-src-tarball" -a -n "$2" ]
202  then  then
203   die "no BINDIR variable found in /etc/mage.rc"   # set correct SMAGENAME
204  fi   SMAGENAME="$2"
205     MD5DIR="$(dirname ${SMAGENAME})/md5"
206    
207  if [ -z "${CHOST}" ]   echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"
208  then  
209   die "no CHOST variable found in /etc/mage.rc"   smagesource ${SMAGENAME} || die "regen: smage2 not found"
210    
211     if [[ -d ${SOURCEDIR}/${PNAME} ]]
212     then
213     echo -e "${COLGREEN}Deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
214     rm -rf ${SOURCEDIR}/${PKGNAME}
215     fi
216    
217     download_sources
218     source_pkg_build ${SMAGENAME}
219     exit 0
220  fi  fi
221    
222  if [ -z "${CFLAGS}" ]  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
223  then  then
224   die "no CFLAGS variable found in /etc/mage.rc"   SRCPKGTARBALL="${2}"
225     msetfeature "srcpkgtarball"
226    
227     # abort if given file is not a source pkg
228     [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
229    
230     # set correct SMAGENAME; use the one that the src_pkg provide
231     # /path/to/SOURCEDIR/PNAME/SMAGENAME
232     SMAGENAME="${SOURCEDIR}/$(basename ${SRCPKGTARBALL%-*-*})/$(basename ${SRCPKGTARBALL} .${SRCPKGSUFFIX}).${SMAGESUFFIX}"
233    
234     echo -e "${COLGREEN}Using src-tarball ${COLBLUE}${SRCPKGTARBALL}${COLGREEN} ...${COLDEFAULT}"
235    
236     [[ ! -d ${SOURCEDIR} ]] && install -d ${SOURCEDIR}
237    
238     # unpack srctarball
239     [[ ! -f ${SRCPKGTARBALL} ]] && die "Error: ${SRCPKGTARBALL} does not exist. Aborting."
240    
241     tar xvjf ${SRCPKGTARBALL} -C ${SOURCEDIR} || die  "Error unpackung src-tarball ${SRCPKGTARBALL}"
242    
243     [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"
244  fi  fi
245    
246  if [ -z "${CXXFLAGS}" ]  if [ "$1" == "--resume" -a -n "$2" ]
247  then  then
248   die "no CXXFLAGS variable found in /etc/mage.rc"   msetfeature "resume"
249     SMAGENAME="$2"
250  fi  fi
251    
252    [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."
253    [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&
254     die "File '$(basename ${SMAGENAME})' is not a sMage v${SMAGEVERSION} file. Aborting."
255    [ -z "${SOURCEDIR}" ] && die "\$SOURCEDIR not found. Please setup your ${MAGERC} correctly."
256    [ -z "${SMAGESCRIPTSDIR}" ] && die "\$SMAGESCRIPTSDIR not found. Please setup your ${MAGERC} correctly."
257    [ -z "${SMAGE2RSYNC}" ] && die "\$SMAGE2RSYNC not found. Please setup your ${MAGERC} correctly."
258    [ -z "${BINDIR}" ] && die "no BINDIR variable found in ${MAGERC}"
259    [ -z "${CHOST}" ] && die "no CHOST variable found in ${MAGERC}"
260    [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"
261    [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
262    
263  source ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
264  PKGNAME="${PNAME}-${PVER}-${CHOST%%-*}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}"
265  MD5DIR="$(dirname ${SMAGENAME})/md5"  MD5DIR="$(dirname ${SMAGENAME})/md5"
266    SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"
267    
268  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
269  echo "Compiling ${PKGNAME}"  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"
270    
271  # auto regen mage tree if requested  if mqueryfeature "srcpkgbuild"
272  regen_mage_tree  then
273     if [[ -d ${SOURCEDIR}/${PNAME} ]]
274     then
275     echo -e "${COLBLUE}===${COLGREEN} deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
276     rm -rf ${SOURCEDIR}/${PNAME}
277     fi
278    fi
279    
280  # download sources  # download sources
281  download_sources  mqueryfeature "srcpkgtarball" || download_sources
282    
283  # fixes some issues with these functions  # fixes some issues with these functions
284  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
285  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
286    export -f src_check || die "src_check export failed"
287  export -f src_install || die "src_install export failed"  export -f src_install || die "src_install export failed"
288    
289  # fixes some compile issues  # fixes some compile issues
290  export CHOST="${CHOST}" || die "CHOST export failed"  export CHOST="${CHOST}" || die "CHOST export failed"
291  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"
292  export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"  if [[ -z ${CXXFLAGS} ]]
293    then
294     export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"
295    else
296     export CXXFLAGS="${CXXFLAGS}" || die "CXXFLAGS export failed"
297    fi
298    export LDFLAGS="${LDFLAGS}" || die "LDFLAGS export failed"
299  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
300  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
301    
   
302  # setup distcc  # setup distcc
303  # distcc mus be setup *before* ccache, as ccache need to be before distcc in path  # setup for distcc goes *before* ccache, so ccache comes before distcc in path
304  if [ "${SMAGE_USE_DISTCC}" == "true" ]  mqueryfeature "distcc" && setup_distcc_environment
305  then  
306   setup_distcc_environment  # setup icecc
307  fi  # setup for icecc goes *before* ccache, so ccache comes before icecc in path
308    mqueryfeature "icecc" && setup_icecc_environment
309    
310  # setup ccache  # setup ccache
311  if [ "${SMAGE_USE_CCACHE}" == "true" ]  mqueryfeature "ccache" && setup_ccache_environment
312    
313    if mqueryfeature "resume"
314  then  then
315   setup_ccache_environment   echo -e "${COLMAGENTA}Resume requested; continuing previous build${COLDEFAULT}"
316  fi  
317     # setup build logging
318     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
319     if [[ -f /var/log/smage/${PKGNAME}.log.bz2 ]]
320     then
321     bunzip2 -f /var/log/smage/${PKGNAME}.log.bz2
322     fi
323     echo -e "### Resume started on $(date) ###\n" >> /var/log/smage/${PKGNAME}.log
324    
325    else
326     # clean up builddir if a previously one exist
327     if [ -d ${BUILDDIR} ]
328     then
329     rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
330     fi
331     install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
332    
333  # small sleep to show our settings   # clean up srcdir if a previously unpacked one exist
334  sleep 1   if [ -d ${SRCDIR} ]
335     then
336     rm -rf ${SRCDIR}
337     fi
338    
339  #debug   # clean up bindir if a previous build exist or create a new one
340  #echo "CC=${CC}"   if [ -d ${BINDIR} ]
341  #echo "CXX=${CXX}"   then
342  #echo "DISTCC_DIR=${DISTCC_DIR}"   rm -rf ${BINDIR}
343  #echo "PATH: ${PATH}"   fi
344  #echo "--------------------------------------"   install -d ${BINDIR} || die "couldn't create \$BINDIR."
 #env  
 #echo "--------------------------------------"  
 #read  
 #debug end  
345    
346  # cleans up build if a previously one exists   # clean up package temp dir if a previous build exist
347  if [ -d ${BUILDDIR} ]   if [ -d ${BUILDDIR}/${PKGNAME} ]
348  then   then
349   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   rm -rf ${BUILDDIR}/${PKGNAME}
350     fi
351    
352     # clean up stamps dir
353     if [ -d ${BUILDDIR}/.stamps ]
354     then
355     rm -rf ${BUILDDIR}/.stamps
356     fi
357    
358     # setup build logging
359     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
360     echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log
361  fi  fi
 install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  
362    
363  # cleans up srcdir if a previously unpacked one exists  if [[ ${PKGTYPE} = virtual ]]
 if [ -d ${SRCDIR} ]  
364  then  then
365   rm -rf ${SRCDIR}   echo "virtual package detected; nothing will be build ..."
366     # automatically set !pkgbuild here too
367     msetfeature "!pkgbuild"
368    else
369     ( run_resume src_prepare || src_prepare ) | ${SMAGE_LOG_CMD}
370     die_pipestatus 0 "src_prepare failed"
371     resume_stamp src_prepare
372     step_by_step src_prepare
373    
374     ( run_resume src_compile || src_compile ) | ${SMAGE_LOG_CMD}
375     die_pipestatus 0 "src_compile failed"
376     resume_stamp src_compile
377     step_by_step src_compile
378    
379     # only run checks if requested
380     if mqueryfeature "!check"
381     then
382     echo "!check detected; src_check() will not be run!" | ${SMAGE_LOG_CMD}
383     else
384     ( run_resume src_check || src_check ) | ${SMAGE_LOG_CMD}
385     die_pipestatus 0 "src_check failed"
386     resume_stamp src_check
387     fi
388     step_by_step src_check
389    
390     # build several subpackages
391     if [[ -n ${SPLIT_PACKAGES} ]]
392     then
393     # save bindir & pname
394     split_save_variables
395     export SAVED_BINDIR="${BINDIR}"
396     for subpackage in ${SPLIT_PACKAGES}
397     do
398     split_info_${subpackage}
399     if [[ ${PKGTYPE} = virtual ]]
400     then
401     echo
402     echo -en "${COLBLUE}*** ${COLDEFAULT}"
403     echo -en "Virtual package detected"
404     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
405     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
406    
407     echo "virtual package detected; nothing will be build ..."
408     # automatically set !pkgbuild here too
409     msetfeature "!pkgbuild"
410     else
411     if typeset -f src_install_${subpackage} > /dev/null
412     then
413     # export subpackage bindir
414     export BINDIR="${SAVED_BINDIR}_${subpackage}"
415     # export PNAME, several internal function and include
416     # rely on this variable
417     export PNAME="${subpackage}"
418    
419     echo
420     echo -en "${COLBLUE}*** ${COLDEFAULT}"
421     echo -en "Running ${COLGREEN}split src_install()${COLDEFAULT}"
422     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
423     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
424    
425     ( run_resume src_install_${subpackage} || src_install_${subpackage} ) | ${SMAGE_LOG_CMD}
426     die_pipestatus 0 "src_install_${subpackage} failed"
427     resume_stamp src_install_${subpackage}
428     step_by_step src_install_${subpackage}
429     fi
430     fi
431     # restore smage environment
432     split_restore_variables
433     done
434     # unset all saved smage variables
435     split_unset_variables
436     else
437     ( run_resume src_install || src_install ) | ${SMAGE_LOG_CMD}
438     die_pipestatus 0 "src_install failed"
439     resume_stamp src_install
440     step_by_step src_install
441     fi
442  fi  fi
443    
444  # cleans up bindir if a previous build exists or creates a new one  # echo for sake of good-looking
445  if [ -d ${BINDIR} ]  echo
446    
447    if mqueryfeature "!compressdoc"
448    then
449     echo -e "!compressdoc detected; documentation will not be compressed ..."
450    elif mqueryfeature "!pkgbuild"
451  then  then
452   rm -rf ${BINDIR}   echo "!pkgbuild detected; skipping documentation compression..."
453    else
454     # compressing doc, info & man files
455     if [[ -n ${SPLIT_PACKAGES} ]]
456     then
457     # save smage environment
458     split_save_variables
459     for subpackage in ${SPLIT_PACKAGES}
460     do
461     # honor split_info
462     split_info_${subpackage}
463     if [[ ${PKGTYPE} = virtual ]]
464     then
465     # automatically set !pkgbuild here too
466     msetfeature "!pkgbuild"
467     fi
468    
469     if mqueryfeature "!compressdoc"
470     then
471     echo -e "!compressdoc detected; documentation of '${subpackage}' will not be compressed ..."
472     elif mqueryfeature "!pkgbuild"
473     then
474     echo "!pkgbuild detected; skipping documentation compression for '${subpackage}' ..."
475     else
476     run_resume post-mcompressdoc_${subpackage} || mcompressdocs ${BINDIR}_${subpackage}
477     resume_stamp post-mcompressdoc_${subpackage}
478     fi
479     # restore smage environment
480     split_restore_variables
481     done
482     # unset saved variables
483     split_unset_variables
484     else
485     run_resume post-mcompressdoc || mcompressdocs ${BINDIR}
486     resume_stamp post-mcompressdoc
487     fi
488  fi  fi
 install -d ${BINDIR} || die "couldn't create \$BINDIR."  
489    
490  # cleans up package temp dir if a previous build exists  if mqueryfeature "!libtool"
 if [ -d ${BUILDDIR}/${PKGNAME} ]  
491  then  then
492   rm -rf ${BUILDDIR}/${PKGNAME}   if mqueryfeature "!pkgbuild"
493     then
494     echo "!pkgbuild detected; skipping libtool archive stripping ..."
495     else
496     if [[ -n ${SPLIT_PACKAGES} ]]
497     then
498     # save smage environment
499     split_save_variables
500     for subpackage in ${SPLIT_PACKAGES}
501     do
502     # honor split_info
503     split_info_${subpackage}
504     if [[ ${PKGTYPE} = virtual ]]
505     then
506     # automatically set !pkgbuild here too
507     msetfeature "!pkgbuild"
508     fi
509    
510     if mqueryfeature "!libtool"
511     then
512     if mqueryfeature "!pkgbuild"
513     then
514     echo "!pkgbuild detected; skipping libtool archive stripping for '${subpackage}'..."
515     else
516     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
517     run_resume post-mstriplibtoolarchive_${subpackage} || mstriplibtoolarchive ${BINDIR}_${subpackage}
518     resume_stamp post-mstriplibtoolarchive_${subpackage}
519     fi
520     fi
521    
522     # restore smage environment
523     split_restore_variables
524     done
525     # unset saved variables
526     split_unset_variables
527     else
528     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
529     run_resume post-mstriplibtoolarchive || mstriplibtoolarchive ${BINDIR}
530     resume_stamp post-mstriplibtoolarchive
531     fi
532     fi
533  fi  fi
534    
535  # cleans up timestamp if one exists  if mqueryfeature "purge"
 if [ -f /var/tmp/timestamp ]  
536  then  then
537   mage rmstamp   if mqueryfeature "!pkgbuild"
538  fi   then
539     echo "!pkgbuild detected; skipping file purgation ..."
540     else
541     if [[ -n ${SPLIT_PACKAGES} ]]
542     then
543     # save smage environment
544     split_save_variables
545     for subpackage in ${SPLIT_PACKAGES}
546     do
547     # honor split_info
548     split_info_${subpackage}
549     if [[ ${PKGTYPE} = virtual ]]
550     then
551     # automatically set !pkgbuild here too
552     msetfeature "!pkgbuild"
553     fi
554    
555  src_prepare || die "src_prepare failed"   if mqueryfeature "purge"
556  src_compile || die "src_compile failed"   then
557  src_install || die "src_install failed"   if mqueryfeature "!pkgbuild"
558     then
559     echo "!pkgbuild detected; skipping file purgation for '${subpackage}' ..."
560     else
561     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
562     run_resume post-mpurgetargets_${subpackage} || mpurgetargets ${BINDIR}_${subpackage}
563     resume_stamp post-mpurgetargets_${subpackage}
564     fi
565     fi
566    
567     # restore smage environment
568     split_restore_variables
569     done
570     # unset saved variables
571     split_unset_variables
572     else
573     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
574     run_resume post-mpurgetargets || mpurgetargets ${BINDIR}
575     resume_stamp post-mpurgetargets
576     fi
577     fi
578    fi
579    
580  # compressing doc, info & man files  # stripping all bins and libs
581  echo -e "Compressing man-pages ..."  if mqueryfeature "!strip"
582  if [ -d ${BUILDDIR}/builded/usr/share/man ]  then
583     echo -e "!strip detected; package will not be stripped ..."
584    elif mqueryfeature "!pkgbuild"
585  then  then
586   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/man   echo "!pkgbuild detected; skipping stripping of the package ..."
587    else
588     if [[ -n ${SPLIT_PACKAGES} ]]
589     then
590     # save smage environment
591     split_save_variables
592     for subpackage in ${SPLIT_PACKAGES}
593     do
594     # honor split_info
595     split_info_${subpackage}
596     if [[ ${PKGTYPE} = virtual ]]
597     then
598     # automatically set !pkgbuild here too
599     msetfeature "!pkgbuild"
600     fi
601    
602     if mqueryfeature "!strip"
603     then
604     echo -e "!strip detected; package '${subpackage}' will not be stripped ..."
605     elif mqueryfeature "!pkgbuild"
606     then
607     echo "!pkgbuild detected; skipping stripping of the package '${subpackage}' ..."
608     else
609     echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
610     run_resume post-mstripbins_${subpackage} || mstripbins ${BINDIR}_${subpackage}
611     resume_stamp post-mstripbins_${subpackage}
612     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
613     run_resume post-mstriplibs_${subpackage} || mstriplibs ${BINDIR}_${subpackage}
614     resume_stamp post-mstriplibs_${subpackage}
615     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
616     run_resume post-mstripstatic_${subpackage} || mstripstatic ${BINDIR}_${subpackage}
617     resume_stamp post-mstripstatic_${subpackage}
618     fi
619    
620     # restore smage environment
621     split_restore_variables
622     done
623     # unset saved variables
624     split_unset_variables
625     else
626     echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
627     run_resume post-mstripbins || mstripbins ${BINDIR}
628     resume_stamp post-mstripbins
629     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
630     run_resume post-mstriplibs || mstriplibs ${BINDIR}
631     resume_stamp post-mstriplibs
632     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
633     run_resume post-mstripstatic || mstripstatic ${BINDIR}
634     resume_stamp post-mstripstatic
635     fi
636  fi  fi
637    
638  echo -e "Compressing info-pages ..."  if mqueryfeature "qalint"
 if [ -d ${BUILDDIR}/builded/usr/share/info ]  
639  then  then
640   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info   if mqueryfeature "!pkgbuild"
641     then
642     echo "!pkgbuild detected; skipping QA lint checks ..."
643     else
644     if [[ -n ${SPLIT_PACKAGES} ]]
645     then
646     # save smage environment
647     split_save_variables
648     for subpackage in ${SPLIT_PACKAGES}
649     do
650     # honor split_info
651     split_info_${subpackage}
652     if [[ ${PKGTYPE} = virtual ]]
653     then
654     # automatically set !pkgbuild here too
655     msetfeature "!pkgbuild"
656     fi
657    
658     if mqueryfeature "qalint"
659     then
660     if mqueryfeature "!pkgbuild"
661     then
662     echo "!pkgbuild detected; skipping QA lint checks for '${subpackage}' ..."
663     else
664     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks for '${subpackage}' ...${COLDEFAULT}"
665     mqalint ${BINDIR}_${subpackage}
666     fi
667     fi
668    
669     # restore smage environment
670     split_restore_variables
671     done
672     # unset saved variables
673     split_unset_variables
674     else
675     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks ...${COLDEFAULT}"
676     mqalint ${BINDIR}
677     fi
678     fi
679  fi  fi
680    
681  # stripping all bins and libs  if mqueryfeature "!pkgbuild"
682  case ${NOSTRIP} in  then
683   true|TRUE|yes|y)   echo -e "!pkgbuild detected; Package will not be build ..."
684   echo -e "NOSTRIP=true detected; Package will not be stripped ..."  else
685   ;;   # build several subpackages
686   *)   if [[ -n ${SPLIT_PACKAGES} ]]
  echo -e "Stripping binaries ..."  
  mstripbins ${BINDIR}  
  echo -e "Stripping libraries ..."  
  mstriplibs ${BINDIR}  
  ;;  
 esac  
   
 # the new buildpkg command  
 case ${NOPKGBUILD} in  
  true|TRUE|yes|y)  
  echo -e "NOPGKBUILD=true detected; Package will not be build ..."  
  ;;  
  *)  
  # build serveral targets  
  if [ -n "${MAGE_TARGETS}" ]  
687   then   then
688   for target in ${MAGE_TARGETS}   split_save_variables
689     for subpackage in ${SPLIT_PACKAGES}
690   do   do
691   # check if an special target_pkgbuild exists   # get the right variables for the split
692   if typeset -f ${target}_pkgbuild > /dev/null   export PNAME="${subpackage}"
693     split_info_${PNAME}
694     # fix PCATEGORIE -> PCAT
695     if [[ ! -z ${PCATEGORIE} ]]
696     then
697     PCAT="${PCATEGORIE}"
698     unset PCATEGORIE
699     fi
700     if [[ ${PKGTYPE} = virtual ]]
701     then
702     # automatically set !pkgbuild here too
703     msetfeature "!pkgbuild"
704     fi
705    
706     # jump to next one if !pkgbuild is set in split_info
707     if mqueryfeature "!pkgbuild"
708     then
709     # restore smage environment
710     split_restore_variables
711     continue
712     fi
713    
714     # check if an special subpackage_pkgbuild exists
715     if typeset -f ${PNAME}_pkgbuild > /dev/null
716   then   then
717   # run it   # run it
718   ${target}_pkgbuild   run_resume post-${PNAME}_pkgbuild || ${PNAME}_pkgbuild
719     resume_stamp post-${PNAME}_pkgbuild
720   fi   fi
721   # now create the target package   # now create the target package
722   ${MLIBDIR}/pkgbuild_dir.sh \   run_resume post-pkg_builddir_${PNAME} || ${MLIBDIR}/pkgbuild_dir.sh \
723   "${PNAME}-${target}-${PVER}-${CHOST%%-*}-${PBUILD}" \   "${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
724   ${BINDIR} || die "target: ${target} package-build failed"   "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
725   echo -e "\nPackage ${PNAME}-${target}-${PVER}-${CHOST%%-*}-${PBUILD} successfully builded.\n"   resume_stamp post-pkg_builddir_${PNAME}
726    
727     # build pkg-md5-sum if requested
728     run_resume post-md5sum_${PNAME} || generate_package_md5sum \
729     --pcat "${PCAT}" \
730     --pname "${PNAME}" \
731     --pver "${PVER}" \
732     --pbuild "${PBUILD}" \
733     --parch "${ARCH}"
734     resume_stamp post-md5sum_${PNAME}
735    
736     echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
737    
738     # restore smage environment
739     split_restore_variables
740   done   done
741     # unset all saved smage variables
742     split_unset_variables
743    
744   else   else
745   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"   run_resume post-pkg_builddir || ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"
746   echo -e "\nPackage ${PKGNAME} successfully builded.\n"   resume_stamp post-pkg_builddir
747    
748     # build pkg-md5-sum if requested
749     run_resume post-md5sum || generate_package_md5sum \
750     --pcat "${PCAT}" \
751     --pname "${PNAME}" \
752     --pver "${PVER}" \
753     --pbuild "${PBUILD}" \
754     --parch "${ARCH}"
755     resume_stamp post-md5sum
756    
757     echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"
758     fi
759    
760     # build src-pkg-tarball if requested
761     if mqueryfeature "srcpkgbuild"
762     then
763     run_resume post-srcpkgbuild || source_pkg_build ${SMAGENAME}
764     resume_stamp post-srcpkgbuild
765   fi   fi
766   ;;  fi
767  esac  
768    # auto regen mage tree if requested
769    regen_mage_tree
770    
771    if mqueryfeature "buildlog"
772    then
773     bzip2 -9f /var/log/smage/${PKGNAME}.log
774    else
775     [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log
776    fi
777    
 # for sure  
 unset NOPKGBUILD  
 unset NOSTRIP  
   
778  xtitleclean  xtitleclean
 #echo -e "\nPackage ${PKGNAME} successfully builded.\n"  

Legend:
Removed from v.199  
changed lines
  Added in v.2589